import enum


class G2PBridgeErrorCodes(enum.Enum):
    # Request Validation Errors
    REQUEST_VALIDATION_ERROR = "REQUEST_VALIDATION_ERROR"

    # Disbursement Envelope Errors
    INVALID_PROGRAM_MNEMONIC = "INVALID_PROGRAM_MNEMONIC"
    INVALID_DISBURSEMENT_FREQUENCY = "INVALID_DISBURSEMENT_FREQUENCY"
    INVALID_CYCLE_CODE_MNEMONIC = "INVALID_CYCLE_CODE_MNEMONIC"
    INVALID_NO_OF_BENEFICIARIES = "INVALID_NO_OF_BENEFICIARIES"
    INVALID_NO_OF_DISBURSEMENTS = "INVALID_NO_OF_DISBURSEMENTS"
    INVALID_TOTAL_DISBURSEMENT_AMOUNT = "INVALID_TOTAL_DISBURSEMENT_AMOUNT"
    INVALID_DISBURSEMENT_CURRENCY_CODE = "INVALID_DISBURSEMENT_CURRENCY_CODE"
    INVALID_DISBURSEMENT_SCHEDULE_DATE = "INVALID_DISBURSEMENT_SCHEDULE_DATE"
    DISBURSEMENT_ENVELOPE_NOT_FOUND = "DISBURSEMENT_ENVELOPE_NOT_FOUND"
    DISBURSEMENT_ENVELOPE_ALREADY_CANCELED = "DISBURSEMENT_ENVELOPE_ALREADY_CANCELED"
    INVALID_DISBURSEMENT_ENVELOPE_ID = "INVALID_DISBURSEMENT_ENVELOPE_ID"
    INVALID_DISBURSEMENT_AMOUNT = "INVALID_DISBURSEMENT_AMOUNT"
    INVALID_BENEFICIARY_ID = "INVALID_BENEFICIARY_ID"
    INVALID_BENEFICIARY_NAME = "INVALID_BENEFICIARY_NAME"
    INVALID_NARRATIVE = "INVALID_NARRATIVE"
    INVALID_RECEIPT_TIME_STAMP = "INVALID_RECEIPT_TIME_STAMP"
    DISBURSEMENT_ENVELOPE_DATE_PASSED = "DISBURSEMENT_ENVELOPE_DATE_PASSED"

    # Disbursement Errors
    INVALID_DISBURSEMENT_ID = "INVALID_DISBURSEMENT_ID"
    INVALID_DISBURSEMENT_PAYLOAD = "INVALID_DISBURSEMENT_PAYLOAD"
    ENVELOPE_ALREADY_CANCELLED = "ENVELOPE_ALREADY_CANCELLED"
    NO_OF_DISBURSEMENTS_EXCEEDS_DECLARED = "NO_OF_DISBUESEMENTS_EXCEEDS_DECLARED"
    NO_OF_DISBURSEMENTS_LESS_THAN_ZERO = "NO_OF_DISBURSEMENTS_LESS_THAN_ZERO"
    TOTAL_DISBURSEMENT_AMOUNT_EXCEEDS_DECLARED = (
        "TOTAL_DISBURSEMENT_AMOUNT_EXCEEDS_DECLARED"
    )
    TOTAL_DISBURSEMENT_AMOUNT_LESS_THAN_ZERO = (
        "TOTAL_DISBURSEMENT_AMOUNT_LESS_THAN_ZERO"
    )
    MULTIPLE_ENVELOPES_FOUND = "MULTIPLE_ENVELOPES_FOUND"
    DISBURSEMENT_ENVELOPE_SCHEDULE_DATE_REACHED = (
        "DISBURSEMENT_ENVELOPE_SCHEDULE_DATE_REACHED"
    )
    DISBURSEMENT_ALREADY_CANCELED = "DISBURSEMENT_ALREADY_CANCELED"

    # Account Statement Errors
    STATEMENT_UPLOAD_ERROR = "STATEMENT_UPLOAD_ERROR"

    # Disbursement Recon Errors
    DUPLICATE_DISBURSEMENT = "DUPLICATE_DISBURSEMENT"
    INVALID_REVERSAL = "INVALID_REVERSAL"
    INVALID_ACCOUNT_NUMBER = "INVALID_ACCOUNT_NUMBER"

    # Benefit Program Configuration Errors
    BENEFIT_PROGRAM_CONFIGURATION_NOT_FOUND = "BENEFIT_PROGRAM_CONFIGURATION_NOT_FOUND"
    BENEFIT_PROGRAM_CONFIGURATION_ALREADY_EXISTS = (
        "BENEFIT_PROGRAM_CONFIGURATION_ALREADY_EXISTS"
    )
    BENEFIT_PROGRAM_CONFIGURATION_INVALID = "BENEFIT_PROGRAM_CONFIGURATION_INVALID"
